<?php echo $header; ?>

<ul class="breadcrumb">
    <li class="active"><?php echo lang('header_tab_dashboard'); ?></li>
</ul>

<script>
function draw_status_dashboard()
{
    var STATUSDIV = '#sourcestatustable';
    $(STATUSDIV).empty();
    
    $.getJSON(site_url + '/api/sources/read', function(data) {
        data.sort(sort_alphabetically);
        $.each(data, function(i, d) {
            var sid = d.sid;
            var name = d.name;
            var node = $('<tr>');
            node.appendTo(STATUSDIV);
            $.getJSON(site_url + '/api/system/source_status/' + sid, function(r) {
                var usage = r.diskusage;
                var icon = r.icon;
                var status;
                if(r.status == 'Stopped') {
                    status = 'error';
                } else {
                    status = 'success';
                }
                node.addClass(status);
                node.html('<td><a href="' + site_url + '/sources/' + sid + '">' + name + '</a></td>' +
                                        '<td style="text-align:center">' + usage + '</td>' +
                                        '<td style="text-align:center">' + icon + '</td>' +
                                    '</tr>');
            });
        });
    });
}

function any_are_true(lat)
{
    for(var i=0, l=lat.length;i<l;i++) {
        if(lat[i] == true) {
            return true;
        }
    }
    return false;
}

function make_popover_content(begindate, enddate, state, sid)
{
    var popover = '';
    var queryurl = site_url + "/sources/queries/" + sid;
    var queryarg = {    'q[rawquery]': '',
                        'q[aggregate_csv]': 'dstip,srcip',
                        'q[begindate]': begindate,
                        'q[enddate]': enddate };
    var rurl;
    var reporturl = site_url + "/sources/reports/" + sid;
    var reportarg = {   'q[begindate]': begindate,
                        'q[enddate]': enddate,
                        'q[top]': 10,
                        'q[toporder]': 'bytes'}
    
    var full_queryurl = queryurl + '?' + $.param(queryarg);
    
    if(state == false) {
        popover += '<p><?php echo lang('dashboard_aberrant_popover_normal'); ?></p>';
    } else {
        popover += '<p><?php echo lang('dashboard_aberrant_popover_abnormal'); ?></p>';
    }
    
    popover += '<hr /><p><strong><?php echo lang('dashboard_aberrant_timeframe_title'); ?></strong></p>';
    
    popover += "<ul>";
    popover += "<li><a href=\"" + full_queryurl + "\"><?php echo lang('query'); ?></a></li>";
    var spargs = $.extend({}, reportarg);
    spargs['q[toptype]'] = 'srcport';
    rurl = reporturl + '?' + $.param(spargs);
    popover += "<li><a href=\"" + rurl + "\"><?php echo lang('dashboard_aberrant_timeframe_tt1'); ?></a></li>";
    var siargs = $.extend({}, reportarg);
    siargs['q[toptype]'] = 'srcip';
    rurl = reporturl + '?' + $.param(siargs);
    popover += "<li><a href=\"" + rurl + "\"><?php echo lang('dashboard_aberrant_timeframe_tt2'); ?></a></li>";
    var dpargs = $.extend({}, reportarg);
    dpargs['q[toptype]'] = 'dstport';
    rurl = reporturl + '?' + $.param(dpargs);
    popover += "<li><a href=\"" + rurl + "\"><?php echo lang('dashboard_aberrant_timeframe_tt3'); ?></a></li>";
    var diargs = $.extend({}, reportarg);
    diargs['q[toptype]'] = 'dstip';
    rurl = reporturl + '?' + $.param(diargs);
    popover += "<li><a href=\"" + rurl + "\"><?php echo lang('dashboard_aberrant_timeframe_tt4'); ?></a></li>";
    popover += "</ul>";
    

        
    var queryurl = begindate + " -> " + enddate;
    return popover;
}

function get_nfdump_datestring(dateobj)
{
    var year = dateobj.getFullYear();
    
    // Javascript's month's are ZERO INDEXED, WTF !@#!@#
    var month = dateobj.getMonth() + 1;
    if(month < 10) {
        month = '0' + month;
    }
    
    var day = dateobj.getDate();
    if(day < 10) {
        day = '0' + day;
    }
    
    var hour = dateobj.getHours();
    if(hour < 10) {
        hour = '0' + hour;
    }
    
    var minute = dateobj.getMinutes();
    if(minute < 10) {
        minute = '0' + minute;
    }
    
    var nf = year + '/' + month + '/' + day + '.' + hour + ':' + minute;
    return nf;
}

function close_pop(node)
{
    $('.abb').popover('hide');
}


function sort_alphabetically(a,b)
{
    return b.name.toLowerCase() < a.name.toLowerCase();
}

function load_check_tables()
{
    load_checks(0, 'ok');
    load_checks(1, 'warning');
    load_checks(2, 'critical');
    load_checks(undefined, 'all');
}

function load_checks(status, target)
{
    var api_url = site_url + '/api/checks/read';
    var tbody = '#tbody-' + target;
    var count = '#count-' + target;
    
    $(tbody).empty();
    
    if(status != undefined) {
        var api_arg = {'q[lastcode]': status}
    } else {
        var api_args = {};
    }
    
    $.getJSON(api_url, api_arg, function(data) {
        if(data.error || data.length == 0) {
            $(tbody).append('<tr><td colspan="999"><?php echo lang('dashboard_checks_none_found'); ?></td></tr>');
            $(count).html('0');
        } else {
        
            $.each(data, function(i, d) {
                var tr = $('<tr>');
                var state;
                
                switch(parseInt(d.lastcode)) {
                    case 0:
                        state = 'OK';
                        break;
                    case 1:
                        state = 'WARNING';
                        break;
                    case 2:
                        state = 'CRITICAL';
                        break;
                    case 3:
                    default:
                        state = 'UNKNOWN';
                        break;
                }
                
                $('<td>', {'text': d.name}).appendTo(tr);
                $('<td>', {'text': state, 'class': state}).appendTo(tr);
                $('<td>', {'text': d.laststdout.split('|')[0]}).appendTo(tr);
                
                tr.appendTo(tbody);
                $(count).html(data.length);
            });
        }
    });
}

function draw_aberrancy_dashboard_titles(meta, len)
{
    var t = $('thead.aberrancy');
    var start = meta.start
    var tr = $('<tr>');
    $('<th>', {'text': 'Source'}).appendTo(tr);
    
    var i = 0;
    for(var i=0; i<len; i++) {
        var tmp_start = new Date(start * 1000);
        var hours = tmp_start.getHours();
        if(hours < 10) {
            hours = '0' + hours;
        }
        
        var minutes = tmp_start.getMinutes();
        if(minutes < 10) {
            minutes = '0' + minutes;
        }
        
        $('<th>', { 'text': hours + ':' + minutes,
                    'style': 'margin:0 auto;' }).appendTo(tr);
        start += meta.step;
    }
    
    $.each(t, function(i, d) {
        $(d).html(tr.clone(true));
    });
}

function draw_aberrancy_viz()
{
    var ok_target = '#tbody-aberrant-ok';
    var bad_target = '#tbody-aberrant-critical';
    var all_target = '#tbody-aberrant-all';
    var ok_seen = false;
    var crit_seen = false;
    
    $(ok_target).html('<td colspan="999">No entries.</td>');
    $(bad_target).html('<td colspan="999">No entries.</td>');
    
    $('#aberrant-count-ok').html('0');
    $('#aberrant-count-critical').html('0');
    $('#aberrant-count-all').html('0');
    
    $('thead.aberrancy').empty();
    var first = true;
    
    $.getJSON(site_url + '/api/sources/read', function(data) {
        
        $.each(data, function(i, d) {
            $.getJSON(site_url + '/api/graphs/failures', {sid: d.sid, begindate: '-60 minutes', enddate: '-5 minutes'}, function(dz) {
                
                if(first == true) {
                    draw_aberrancy_dashboard_titles(dz.meta, dz.data.length);
                    first = false;
                }
                
                var tr = $('<tr>');
                var status = undefined;
                var current = dz.meta.start
                $('<td>', {'text': d.name, 'class': 'aberr-title'}).appendTo(tr);
                
                $.each(dz.data, function(i, dy) {
                    
                    begindate = new Date(current * 1000);
                    enddate = new Date((current + dz.meta.step) * 1000);
                    
                    begindate = get_nfdump_datestring(begindate);
                    enddate = get_nfdump_datestring(enddate);
                    
                    var popover_content = make_popover_content(begindate, enddate, dy, d.sid);
                    
                    var klass = dy ? 'CRITICAL' : 'OK';
                    status = (status || dy);
                    var new_td = $('<td>', {'class': 'abb ' + klass,
                                            'data-title': '<?php echo lang('dashboard_aberrant_popover_title'); ?><button onclick=\'close_pop(this);\' class=\'close close-popover\'>&times;</button>',
                                            'data-html': 'true',
                                            'data-placement': 'left',
                                            'data-content': popover_content,
                                            'begindate': begindate,
                                            'enddate': enddate,
                                            'data-container': 'body'});
                    new_td.mouseover(function() { 
                        $(this).removeClass(klass); 
                        $(this).addClass(klass + '-mouseover'); 
                    });
                    new_td.mouseout(function() { 
                        $(this).removeClass(klass + '-mouseover'); 
                        $(this).addClass(klass); 
                    });
                    new_td.appendTo(tr);
                    
                    current += dz.meta.step;
                });
                
                if(status) {
                    var ntr = tr.clone(true);
                    if(crit_seen == true) {
                        ntr.appendTo(bad_target);
                    } else {
                        $(bad_target).html(ntr);
                        crit_seen = true;
                    }
                    var critical = parseInt($('#aberrant-count-critical').html());
                    $('#aberrant-count-critical').html(++critical);
                } else {
                    var ntr = tr.clone(true);
                    if(ok_seen == true) {
                        ntr.appendTo(ok_target);
                    } else {
                        $(ok_target).html(ntr);
                        ok_seen = true;
                    }
                    var ok = parseInt($('#aberrant-count-ok').html());
                    $('#aberrant-count-ok').html(++ok);
                }
                var total = parseInt($('#aberrant-count-all').html());
                $('#aberrant-count-all').html(++total);
                if(crit_seen || ok_seen) {
                    tr.clone(true).appendTo(all_target);
                } else {
                    $(all_target).html(tr.clone(true));
                }
                $('.abb').popover();
                $('.abb').on('shown.bs.popover', function() { $('.abb').not(this).popover('hide'); });
            });
        });
    });
}

$(document).ready(function() {
    
    var gauges = {};
    
    gauges['cpu'] = create_gauge('cpustatus', 'CPU', '/nagiosna/index.php/api/system/cpu_status', 'cpu_usage', 1);
    gauges['disk'] = create_gauge('diskstatus', 'Disk', '/nagiosna/index.php/api/system/root_drive_status', 'percent', 1); 
    gauges['memory'] = create_gauge('memorystatus', 'Memory', '/nagiosna/index.php/api/system/memory_status', 'used_percent', 1);
    gauges['swap'] = create_gauge('swapstatus', 'Swap', '/nagiosna/index.php/api/system/memory_status', 'swap_percent', 1);
    
    for(var key in gauges) {
        gauges[key].render();
    }
    
    setInterval(function() {
        for(var key in gauges) {
            gauges[key].redraw(500);
        }
    }, 5000);
    
    draw_status_dashboard();
    
    draw_aberrancy_viz();
    
    load_check_tables()
    setInterval(function() {
        load_check_tables();
    }, 300000);
    
    setInterval(function() {
        draw_aberrancy_viz();
    }, 300000);
});

</script>

<div class="container">
    <h5><?php echo lang('dashboard_checks'); ?></h5>
    <div class='row-fluid'>
        <div class='span12 well'>
            <div class="tabbable tabs-left">
                <ul style="margin:0px;border:0;" class="nav nav-tabs">
                    <li><a href="#ok" data-toggle="tab"><span class="OK">&#9830;</span>&nbsp;<?php echo lang('dashboard_checks_ok'); ?>&nbsp;(<span id='count-ok'></span>)</a></li>
                    <li><a href="#warning" data-toggle="tab"><span class="WARNING">&#9830;</span>&nbsp;<?php echo lang('dashboard_checks_warning'); ?>&nbsp;(<span id='count-warning'></span>)</a></li>
                    <li class="active"><a href="#critical" data-toggle="tab"><span class="CRITICAL">&#9830;</span>&nbsp;<?php echo lang('dashboard_checks_critical'); ?>&nbsp;(<span id='count-critical'></span>)</a></li>
                    <li><a href="#all" data-toggle="tab"><span class="ALL">&#9830;</span>&nbsp;<?php echo lang('dashboard_checks_all'); ?>&nbsp;(<span id='count-all'></span>)</a></li>
                </ul>
                <div class="tab-content white-back">
                    <div class="tab-pane make-me-scroll extra-padding" id="ok">
                        <table class="table table-striped table-hover">
                            <thead>
                                <th><?php echo lang('dashboard_checks_table_name'); ?></th>
                                <th><?php echo lang('dashboard_checks_table_status'); ?></th>
                                <th width="*"><?php echo lang('dashboard_checks_table_message'); ?></th>
                            </thead>
                            <tbody id="tbody-ok"></tbody>
                        </table>
                    </div>
                    <div class="tab-pane make-me-scroll extra-padding" id="warning">
                        <table class="table table-striped table-hover ">
                            <thead>
                                <th><?php echo lang('dashboard_checks_table_name'); ?></th>
                                <th><?php echo lang('dashboard_checks_table_status'); ?></th>
                                <th width="*"><?php echo lang('dashboard_checks_table_message'); ?></th>
                            </thead>
                            <tbody id="tbody-warning"></tbody>
                        </table>
                    </div>
                    <div class="tab-pane active make-me-scroll extra-padding" id="critical">
                        <table class="table table-striped table-hover ">
                            <thead>
                                <th><?php echo lang('dashboard_checks_table_name'); ?></th>
                                <th><?php echo lang('dashboard_checks_table_status'); ?></th>
                                <th width="*"><?php echo lang('dashboard_checks_table_message'); ?></th>
                            </thead>
                            <tbody id="tbody-critical"></tbody>
                        </table>
                    </div>
                    <div class="tab-pane make-me-scroll extra-padding" id="all">
                        <table class="table table-striped table-hover ">
                            <thead>
                                <th><?php echo lang('dashboard_checks_table_name'); ?></th>
                                <th><?php echo lang('dashboard_checks_table_status'); ?></th>
                                <th width="*"><?php echo lang('dashboard_checks_table_message'); ?></th>
                            </thead>
                            <tbody id="tbody-all"></tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <h5><?php echo lang('dashboard_system'); ?></h5>
    <div class="row-fluid">
        <div class="span12 well">
            <div class="gauge centerme span2">
                <strong><?php echo lang('dashboard_system_cpu'); ?> %</strong>
                <div id='cpustatus'></div>
            </div>
            <div class="gauge centerme span2">
                <strong><?php echo lang('dashboard_system_disk'); ?> %</strong>
                <div id='diskstatus'></div>
            </div>
            <div class="gauge centerme span2">
                <strong><?php echo lang('dashboard_system_memory'); ?> %</strong>
                <div id='memorystatus'></div>
            </div>
            <div class="gauge centerme span2">
                <strong><?php echo lang('dashboard_system_swap'); ?> %</strong>
                <div id='swapstatus'></div>
            </div>
            <div class="span4">
                <div class="make-me-scroll" id="sourcestatusdiv">
                    <table class="source-scroll table table-condensed">
                        <thead>
                            <tr>
                                <th><?php echo lang('dashboard_system_table_name'); ?></th>
                                <th style="width: 15px;"><?php echo lang('dashboard_system_table_usage'); ?></th>
                                <th style="width: 15px;"><?php echo lang('dashboard_system_table_status'); ?></th>
                            </tr>
                        </thead>
                        <tbody id="sourcestatustable">
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
    <h5><?php echo lang('dashboard_aberrant'); ?></h5>
    <div class="row-fluid">
        <div class="span12 well">
            <div class="tabbable tabs-left">
                <ul style="margin:0px;border:0;" class="nav nav-tabs">
                    <li><a href="#aberrant-ok" data-toggle="tab"><span class="OK">&#9830;</span>&nbsp;<?php echo lang('dashboard_checks_ok'); ?>&nbsp;(<span id='aberrant-count-ok'></span>)</a></li>
                    <li class="active"><a href="#aberrant-critical" data-toggle="tab"><span class="CRITICAL">&#9830;</span>&nbsp;<?php echo lang('dashboard_checks_critical'); ?>&nbsp;(<span id='aberrant-count-critical'></span>)</a></li>
                    <li><a href="#aberrant-all" data-toggle="tab"><span class="ALL">&#9830;</span>&nbsp;<?php echo lang('dashboard_checks_all'); ?>&nbsp;(<span id='aberrant-count-all'></span>)</a></li>
                </ul>
                <div class="tab-content white-back">
                    <div class="tab-pane make-me-scroll extra-padding" id="aberrant-ok">
                        <table class="table table-striped table-hover">
                            <thead class="aberrancy"></thead>
                            <tbody id="tbody-aberrant-ok"></tbody>
                        </table>
                    </div>
                    <div class="tab-pane active make-me-scroll extra-padding" id="aberrant-critical">
                        <table class="table table-striped table-hover">
                            <thead class="aberrancy"></thead>
                            <tbody id="tbody-aberrant-critical"></tbody>
                        </table>
                    </div>
                    <div class="tab-pane make-me-scroll extra-padding" id="aberrant-all">
                        <table class="table table-striped table-hover">
                            <thead class="aberrancy"></thead>
                            <tbody id="tbody-aberrant-all"></tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<?php echo $footer; ?>
